CREATE TABLE class_teachers (teacher_id bigint PRIMARY KEY AUTO_INCREMENT,
groupid bigint,
uid bigint,
linkid bigint
);

CREATE TABLE department_tbl (department_id int PRIMARY KEY AUTO_INCREMENT,
department_nam TEXT NOT NULL, comment TEXT);

CREATE TABLE txt_level_tbl (txt_level_id int PRIMARY KEY AUTO_INCREMENT,
txt_level_nam TEXT NOT NULL, comment TEXT);

CREATE TABLE difficulty_tbl (difficulty_id int PRIMARY KEY AUTO_INCREMENT,
difficulty_nam TEXT NOT NULL, comment TEXT);

CREATE TABLE test_txt_tbl (text_id bigint PRIMARY KEY AUTO_INCREMENT,
text_title text NOT NULL,
exp_dif int DEFAULT NULL,
real_dif int DEFAULT NULL,
level int DEFAULT NULL,
content text NOT NULL,
teacher_id bigint,
registered_date timestamp,
last_modifer_id bigint,
last_modified_date timestamp,
department_id int NOT NULL DEFAULT 1,
comment text,
av_file text,av_repeat int,
img_file text);

CREATE TABLE question_tbl (question_id bigint PRIMARY KEY AUTO_INCREMENT,
text_id bigint NOT NULL,
exp_dif int DEFAULT NULL,
real_dif int DEFAULT NULL,
level int DEFAULT NULL,
content text NOT NULL,
teacher_id bigint,
registered_date timestamp,
last_modifer_id bigint,
last_modified_date timestamp,
comment text,
answer int NOT NULL,
example text DEFAULT NULL,
rep_key character varying(20) DEFAULT '',
max_length int DEFAULT NULL,
max_words int DEFAULT NULL,
question_av_file text,
question_repeat int DEFAULT 1,
ave_percent int DEFAULT 0,
ave_sd float8) TYPE=MyISAM;

CREATE TABLE item_tbl (
question_id bigint NOT NULL,
item_order character varying(2) NOT NULL,
item_txt text NOT NULL,
is_right int NOT NULL,
comment text,
CONSTRAINT item_tbl_pk PRIMARY KEY(question_id, item_order));

CREATE TABLE template_tbl (template_id BIGINT PRIMARY KEY AUTO_INCREMENT,
template_name TEXT,
teacher_id bigint,
registered_date timestamp,
last_modifer_id bigint,
last_modified_date timestamp,sd_score float8,ave_score float8,participate_num int,
full_score int);

CREATE TABLE test_info_tbl (test_id bigint PRIMARY KEY AUTO_INCREMENT,
test_nam character varying(50) NOT NULL,
teacher_id bigint,
groupid bigint,
make_date timestamp NOT NULL,
test_date timestamp,
duration int DEFAULT 0,
exp_score float8 DEFAULT 0,real_score float8 DEFAULT 0,
status int NOT NULL DEFAULT 0,
partici_num int DEFAULT 0,sd_score float8 DEFAULT 0,
test_type smallint DEFAULT 0,
template_type bigint,
full_score int);

CREATE TABLE tested_question_tbl (
tested_id bigint PRIMARY KEY AUTO_INCREMENT,
question_type bigint,
test_id bigint,
score int DEFAULT 0,
question_order int DEFAULT 0,
comment text,
ave_score float8 DEFAULT 0,
sddev float8 DEFAULT 0,
CONSTRAINT tested_question_tbl_uni UNIQUE(question_type, test_id)
);

CREATE TABLE class_student_tbl (
class_student_id int PRIMARY KEY AUTO_INCREMENT,
uid bigint,
groupid bigint,
student_comment text,
teacher_comment text,
present int DEFAULT 0,status int DEFAULT 0,
st_status int,
linkid bigint,
CONSTRAINT class_student_tbl_uni UNIQUE(uid, groupid));

CREATE TABLE key_word_tbl (
key_word_id bigint PRIMARY KEY AUTO_INCREMENT,
question_id bigint NOT NULL,
key_word_txt character varying(200) binary NOT NULL,
score_weight int NOT NULL DEFAULT 0,
comment text,
CONSTRAINT key_word_tbl_pk UNIQUE(question_id, key_word_txt));

CREATE TABLE answered_item_tbl(
tested_id bigint,
class_student_id int,
answered_item character varying(2),
is_right int DEFAULT NULL,
CONSTRAINT answered_item_tbl_pk UNIQUE(tested_id, class_student_id, answered_item));

CREATE TABLE answered_txt_tbl(
tested_id bigint,
class_student_id int,
answered_txt text NOT NULL,
CONSTRAINT answered_txt_tbl_pk UNIQUE(tested_id, class_student_id));

CREATE TABLE student_test_tbl (
test_id bigint,
class_student_id int,
present int NOT NULL DEFAULT 0,
score int,
st_ts_comment text,
tea_ts_comment text,
sd_score float8 DEFAULT 0,
sd_score_temp float8 DEFAULT 0,
CONSTRAINT student_test_tbl_pk UNIQUE(test_id, class_student_id));

CREATE TABLE answered_score_tbl(
tested_id bigint,
class_student_id int,
score float8 DEFAULT NULL,sd_score float8 DEFAULT 0,
CONSTRAINT answered_score_tbl_pk UNIQUE(tested_id, class_student_id));

CREATE TABLE practice_tbl (
practice_id bigint PRIMARY KEY AUTO_INCREMENT,
practice_title text,
practice_text text,
cre_teacher_id bigint,
cre_student_id bigint,
img_file text, av_file text, level int,
department int,
real_dif int,
exp_dif int,
answer int,
status int,
create_time datetime,
update_time datetime,
comment text,
parent_practice bigint,
parent_question bigint,
is_new int NOT NULL DEFAULT 1,
exp_dur int);

CREATE TABLE practice_result_tbl (practice_result_id bigint PRIMARY KEY AUTO_INCREMENT,
usr_id bigint,
department_id int,
practice_id bigint,
practice_time timestamp DEFAULT now(),
answered text,
is_right tinyint,
duration int);

CREATE TABLE practice_item_tbl (
practice_id bigint,
item_order character varying(4) NOT NULL,
item_txt text NOT NULL,
is_right int NOT NULL,
comment text,
CONSTRAINT item_tbl_practice_pk PRIMARY KEY(practice_id, item_order));

CREATE TABLE practice_key_word_tbl (practice_key_word_id bigint PRIMARY KEY AUTO_INCREMENT,
practice_id bigint,
key_word_txt character varying(200) binary NOT NULL,
score_weight int NOT NULL DEFAULT 0,
comment text,
CONSTRAINT key_word_tbl_practice_pk UNIQUE(practice_id, key_word_txt));

CREATE TABLE practice_flag_tbl (practice_flag_id bigint PRIMARY KEY AUTO_INCREMENT,
usr_id bigint,
practice_id bigint NOT NULL,
CONSTRAINT practice_flg_tbl_pk UNIQUE(practice_id, usr_id)
);

CREATE TABLE practice_show_others_tbl(
practice_id bigint NOT NULL,
usr_id bigint NOT NULL,
CONSTRAINT show_other_tbl_pk UNIQUE(practice_id, usr_id)
);

CREATE TABLE prac_comment_tbl (prac_comment_id bigint PRIMARY KEY AUTO_INCREMENT,
prac_comment text,
usr_id bigint,
practice_id bigint,
parent_comment_id bigint,
positive int DEFAULT 0,
negative int DEFAULT 0,
create_time datetime,
uname text,
del_flag int DEFAULT 0);

CREATE TABLE moshi_tbl (moshi_id bigint PRIMARY KEY AUTO_INCREMENT,
moshi_name text, moshi_com text,
student_id bigint,
teacher_id bigint,
difficulty int,
is_pub int DEFAULT 0,
create_time datetime,
update_time datetime,
duration int,
goal_score int,
is_new int DEFAULT 1,
moshi_type int,
disp_type int  DEFAULT 0,
select_ans_type bigint);

CREATE TABLE  moshi_quiz_type_tbl (
moshi_quiz_type_id bigint PRIMARY KEY AUTO_INCREMENT,
score int,
number int,
type_com text,
is_middle int,
moshi_id bigint,
department int,
difficulty int,
level int
);

CREATE TABLE ansto_whole_moshi_tbl (
ansto_whole_moshi_id bigint PRIMARY KEY AUTO_INCREMENT,
moshi_id bigint,
duration int,
score int,
uid bigint,
moshi_time datetime
);

CREATE TABLE ind_ansto_moshi_tbl (
ansto_whole_moshi_id bigint,
practice_id bigint,
moshi_quiz_type_id bigint,
prac_result_id bigint,
question_id bigint,
answered text,
is_right int,
get_score int,
ans_order int,CONSTRAINT ansto_order UNIQUE (ansto_whole_moshi_id, ans_order),
CONSTRAINT ansto_prac UNIQUE (ansto_whole_moshi_id, prac_result_id));

CREATE TABLE moshi_show_others_tbl (
moshi_id bigint,
usr_id bigint
);

CREATE TABLE moshi_show_group_tbl (
moshi_id bigint,
class_id bigint,
CONSTRAINT mc_link PRIMARY KEY (moshi_id, class_id)
);

CREATE TABLE eval_prac_tbl (
uid bigint,
practice_id bigint,
eval int, createtime datetime,
CONSTRAINT upkey UNIQUE(uid, practice_id));

CREATE TABLE eval_comment_tbl (
uid bigint,
prac_comment_id bigint,
eval int, createtime datetime,
CONSTRAINT uckey UNIQUE(uid, prac_comment_id));

CREATE TABLE rec_calc_status_tbl (
start_time datetime, end_time datetime,status int,
admin_id bigint,
reco_type int, include_peason int,
include_flag int, include_eval int);

CREATE TABLE flag_tanimoto_tbl (
tanimoto double,
uid1 bigint,
uid2 bigint,
create_time datetime);

CREATE TABLE eval_tanimoto_tbl (
tanimoto double,
uid1 bigint,
uid2 bigint,
create_time datetime);

CREATE TABLE incor_tmp_tbl (
percentage double,
uid bigint,
practice_id bigint,
INDEX uindex(uid), INDEX pracindex(practice_id));

CREATE TABLE tmp_user_avg_tbl (uid bigint primary key,avg_score double);

CREATE TABLE tmp_prac_avg_tbl (practice_id bigint primary key,avg_score double);

CREATE TABLE pearson_user_tbl (
target1 bigint, target2 bigint, pearson_r double,
create_time datetime,
INDEX t1(target1), INDEX t2(target2));

CREATE TABLE pearson_prac_tbl (
target1 bigint, target2 bigint, pearson_r double,
create_time datetime,
INDEX t1(target1), INDEX t2(target2));

CREATE TABLE reco_prac_tbl (
uid bigint, practice_id bigint, relation double,
create_time datetime,
INDEX uidx(uid), INDEX pidx(practice_id));

CREATE TABLE flag_prac_tanimoto_tbl (
tanimoto double,
practice_id1 bigint REFERENCES practice_tbl (practice_id) ,
practice_id2 bigint REFERENCES practice_tbl (practice_id) ,
create_time datetime
);

CREATE TABLE eval_prac_tanimoto_tbl (
tanimoto double,
practice_id1 bigint REFERENCES practice_tbl (practice_id) ,
practice_id2 bigint REFERENCES practice_tbl (practice_id) ,
create_time datetime
);